//---------------------------------------------------------------------------


#pragma hdrstop

#include "PowerColor.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

void __fastcall Color2GL   ( float* Val , TColor Color)
{
 Val[0] = ((float)(Color & 0xff  )) / 255 ;
 Val[1] = ((float)((Color & 0xff00) >> 8)) / 255 ;
 Val[2] = ((float)((Color & 0xff0000) >> 16 )) / 255 ;
}

void __fastcall WeightColor2GL   ( float* Val , TColor Color , float Weight  )
{
 Val[0] = Weight * ((float)( Color & 0xff  )) / 255 ;
 Val[1] = Weight * ((float)((Color & 0xff00) >> 8)) / 255 ;
 Val[2] = Weight * ((float)((Color & 0xff0000) >> 16 )) / 255 ;
}

//---------------------------------------------------------------------------
float __fastcall Color2RedGL   (TColor Color)
{
 return ((float)(0xff & Color)) / 255 ;
}
//---------------------------------------------------------------------------
float __fastcall Color2GreenGL (TColor Color)
{
 return ((float)((0xff00 & Color) >> 8)) / 255 ;
}
//---------------------------------------------------------------------------
float __fastcall Color2BlueGL  (TColor Color)
{
 return ((float)((0xff0000 & Color) >> 16 )) / 255 ;
}
//---------------------------------------------------------------------------
void __fastcall Pow2RGB ( int Sheme , float Value , float* RGB_Array , float ExpVal )
{
  if ( ExpVal )
   Value = exp ( ExpVal * Value ) ;
  switch ( Sheme )
    {
     case  RGB_EXP :
      {
        RGB_Array[2] =  exp( -20*pow(Value - 0.3  , 2 )) ;
        RGB_Array[1] =  exp(  -8*pow(Value - 0.48 , 2 )) ;
        RGB_Array[0] =  exp(  -4*pow(Value - 1    , 2 )) ;
        break ;
      }
     case RGB_GREEN_LINEAR :
      {
        RGB_Array[2] =  0     ;
        RGB_Array[1] =  Value ;
        RGB_Array[0] =  0     ;
        break ;
      }
     default :
      {
        RGB_Array[2] =  Value ;
        RGB_Array[1] =  Value ;
        RGB_Array[0] =  Value ;
        break ;
      }
    }  
}
